#!/usr/bin/env node
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const meow_1 = __importDefault(require("meow"));
const about_1 = __importDefault(require("./cli/about"));
const help_1 = __importDefault(require("./cli/help"));
const save_1 = __importDefault(require("./cli/save"));
const set_1 = __importDefault(require("./cli/set"));
const start_1 = __importDefault(require("./cli/start"));
const stop_1 = __importDefault(require("./cli/stop"));
const cli = (0, meow_1.default)(help_1.default, {
    flags: {
        help: {
            type: "boolean",
            default: false,
            alias: "h",
        },
        version: {
            type: "boolean",
            default: false,
            alias: "v",
        },
    },
});
switch (cli.input[0]) {
    case "set":
        (0, set_1.default)();
        break;
    case "start":
        (0, start_1.default)();
        break;
    case "save":
        (0, save_1.default)();
        break;
    case "stop":
        (0, stop_1.default)();
        break;
    case "about":
        (0, about_1.default)();
        break;
    default:
        cli.showHelp();
        break;
}
