"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ink_1 = require("ink");
const react_1 = __importStar(require("react"));
const Logo_1 = __importDefault(require("./components/Logo"));
const Tips_1 = __importDefault(require("./components/Tips"));
const shelljs_1 = __importDefault(require("shelljs"));
const pm2_1 = __importDefault(require("pm2"));
const MyTable_1 = __importDefault(require("./components/MyTable"));
const Loading_1 = __importDefault(require("./components/Loading"));
const settingHelper_1 = require("./common/settingHelper");
const setting = (0, settingHelper_1.readSetting)() || {};
const SaveView = () => {
    // 提示
    const [tips, setTips] = (0, react_1.useState)({
        isShow: false,
        type: "success",
        message: "",
    });
    // pm2进程表格
    const [pm2List, setPm2List] = (0, react_1.useState)([]);
    const [loadingOption, setLoadingOption] = (0, react_1.useState)({
        isLoading: true,
        text: "正在安装pm2",
    });
    (0, react_1.useEffect)(() => {
        if ((setting.list || []).length === 0) {
            setLoadingOption({ isLoading: false, text: "" });
            setTips({
                isShow: true,
                type: "info",
                message: "没有发现通知，请先设置通知。",
            });
        }
        else {
            const result = shelljs_1.default.exec("npm install pm2 -g", {
                silent: true,
            });
            setLoadingOption({ isLoading: false, text: "" });
            if (result.code === 0) {
                setTips({
                    isShow: true,
                    type: "success",
                    message: "安装pm2成功",
                });
            }
            else {
                setTips({
                    isShow: true,
                    type: "error",
                    message: "安装pm2失败",
                });
                setTimeout(() => {
                    process.exit(1);
                }, 0);
            }
            pm2_1.default.connect(err => {
                if (err) {
                    setTips({
                        isShow: true,
                        type: "error",
                        message: "连接pm2失败",
                    });
                    setTimeout(() => {
                        process.exit(1);
                    }, 0);
                }
                pm2_1.default.start({
                    name: "coder-notifier",
                    script: "coder-notifier",
                    args: "start",
                    log_date_format: "YYYY-MM-DD HH:mm Z",
                }, err => {
                    if (err) {
                        setTips({
                            isShow: true,
                            type: "error",
                            message: "启动coder-notifier进程失败，请检查是否安装成功。",
                        });
                        setTimeout(() => {
                            process.exit(1);
                        }, 0);
                    }
                    else {
                        setTips({
                            isShow: true,
                            type: "success",
                            message: "启动coder-notifier进程成功",
                        });
                        const result = shelljs_1.default.exec("pm2 startup", {
                            silent: true,
                        });
                        shelljs_1.default.exec(result.stdout.replace("sudo", ""), {
                            silent: true,
                        });
                        shelljs_1.default.exec("pm2 save --force", {
                            silent: true,
                        });
                        pm2_1.default.list((err, list) => {
                            if (!err) {
                                const tableData = list.map(item => {
                                    var _a;
                                    return {
                                        id: item.pm_id,
                                        name: item.name,
                                        status: (_a = item.pm2_env) === null || _a === void 0 ? void 0 : _a.status,
                                    };
                                });
                                setPm2List(tableData);
                                setTips({
                                    isShow: true,
                                    type: "success",
                                    message: "完成",
                                });
                                setTimeout(() => {
                                    process.exit(0);
                                }, 0);
                            }
                            else {
                                setTips({
                                    isShow: true,
                                    type: "info",
                                    message: "获取进程列表失败",
                                });
                                setTimeout(() => {
                                    process.exit(1);
                                }, 0);
                            }
                        });
                    }
                });
            });
        }
    }, []);
    return (react_1.default.createElement(ink_1.Box, { flexDirection: 'column' },
        react_1.default.createElement(Logo_1.default, null),
        loadingOption.isLoading && react_1.default.createElement(Loading_1.default, null, loadingOption.text),
        pm2List.length > 0 && (react_1.default.createElement(MyTable_1.default, { title: 'pm2\u8FDB\u7A0B\u5217\u8868', data: (pm2List || []) })),
        react_1.default.createElement(Tips_1.default, { ...tips })));
};
exports.default = SaveView;
