"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const ink_1 = require("ink");
const Input_1 = __importDefault(require("./Input"));
const Select_1 = __importDefault(require("./Select"));
const SetForm = ({ initForm, onError, onConfirm, onHideError, onInfo, }) => {
    const [setup, setSetup] = (0, react_1.useState)(0);
    const [title, setTitle] = (0, react_1.useState)((initForm === null || initForm === void 0 ? void 0 : initForm.title) || "");
    const [message, setMessage] = (0, react_1.useState)((initForm === null || initForm === void 0 ? void 0 : initForm.message) || "");
    const [cycle, setCycle] = (0, react_1.useState)((initForm === null || initForm === void 0 ? void 0 : initForm.cycle) || "day");
    const [week, setWeek] = (0, react_1.useState)((initForm === null || initForm === void 0 ? void 0 : initForm.week) || 1);
    const [time, setTime] = (0, react_1.useState)((initForm === null || initForm === void 0 ? void 0 : initForm.time) || "");
    const [isTurnOn, setIsTurnOn] = (0, react_1.useState)((initForm === null || initForm === void 0 ? void 0 : initForm.isTurnOn) || true);
    const [remark, setRemark] = (0, react_1.useState)((initForm === null || initForm === void 0 ? void 0 : initForm.remark) || "");
    const [schedule, setSchedule] = (0, react_1.useState)((initForm === null || initForm === void 0 ? void 0 : initForm.schedule) || "");
    const weekList = [
        {
            label: "周一",
            value: 1,
        },
        {
            label: "周二",
            value: 2,
        },
        {
            label: "周三",
            value: 3,
        },
        {
            label: "周四",
            value: 4,
        },
        {
            label: "周五",
            value: 5,
        },
        {
            label: "周六",
            value: 6,
        },
        {
            label: "周日",
            value: 7,
        },
    ];
    const cycleList = [
        {
            label: "每天",
            value: "day",
        },
        {
            label: "每周",
            value: "week",
        },
        {
            label: "自定义",
            value: "custom",
        },
    ];
    const isTurnList = [
        {
            label: "是",
            value: true,
        },
        {
            label: "否",
            value: false,
        },
    ];
    const onTitleConfirm = (value) => {
        if (value) {
            setTitle(value);
            setSetup(1);
            onHideError();
        }
        else {
            onError("标题不能为空");
        }
    };
    const onMessageConfirm = (value) => {
        if (value) {
            setMessage(value);
            setSetup(2);
            onHideError();
        }
        else {
            onError("信息不能为空");
        }
    };
    const onSelectCycle = (item) => {
        onHideError();
        setCycle(item.value);
        switch (item.value) {
            case "day":
                setSetup(4);
                break;
            case "week":
                setSetup(3);
                break;
            case "custom":
                setSetup(7);
                onInfo("不会写？举个栗子：每30分钟通知一次（* 0/30 * * * ?）。还是不会？在线生成Cron表达式（ https://www.bejson.com/othertools/cron ）");
                break;
            default:
                break;
        }
    };
    const onSelectWeek = (item) => {
        setWeek(item.value);
        setSetup(4);
        onHideError();
    };
    const onTimeConfirm = (value) => {
        if (/([0-1]\d|2[0-4]):[0-5]\d:[0-5]\d/.test(value)) {
            onHideError();
            setTime(value);
            setSetup(5);
        }
        else {
            onError("时间格式不正确");
        }
    };
    const onSelectIsTurnOn = (item) => {
        onHideError();
        setIsTurnOn(item.value);
        setSetup(6);
    };
    const onRemarkConfirm = (value) => {
        onHideError();
        setRemark(value);
        setSetup(-1);
        onConfirm({
            title,
            message,
            cycle,
            week,
            time,
            schedule,
            isTurnOn,
            remark: value,
        });
    };
    const onScheduleConfirm = (value) => {
        if (value) {
            if (new RegExp(`(((^([0-9]|[0-5][0-9])(\\,|\\-|\\/){1}([0-9]|[0-5][0-9]) )|^([0-9]|[0-5][0-9]) |^(\\* ))((([0-9]|[0-5][0-9])(\\,|\\-|\\/){1}([0-9]|[0-5][0-9]) )|([0-9]|[0-5][0-9]) |(\\* ))((([0-9]|[01][0-9]|2[0-3])(\\,|\\-|\\/){1}([0-9]|[01][0-9]|2[0-3]) )|([0-9]|[01][0-9]|2[0-3]) |(\\* ))((([0-9]|[0-2][0-9]|3[01])(\\,|\\-|\\/){1}([0-9]|[0-2][0-9]|3[01]) )|(([0-9]|[0-2][0-9]|3[01]) )|(\\? )|(\\* )|(([1-9]|[0-2][0-9]|3[01]) )|([1-7] )|( )|([1-7]\\#[1-4] ))((([1-9]|0[1-9]|1[0-2])(\\,|\\-|\\/){1}([1-9]|0[1-9]|1[0-2]) )|([1-9]|0[1-9]|1[0-2]) |(\\* ))(([1-7](\\,|\\-|\\/){1}[1-7])|([1-7])|(\\?)|(\\*)|(([1-7])|([1-7]\\#[1-4]))))|(((^([0-9]|[0-5][0-9])(\\,|\\-|\\/){1}([0-9]|[0-5][0-9]) )|^([0-9]|[0-5][0-9]) |^(\\* ))((([0-9]|[0-5][0-9])(\\,|\\-|\\/){1}([0-9]|[0-5][0-9]) )|([0-9]|[0-5][0-9]) |(\\* ))((([0-9]|[01][0-9]|2[0-3])(\\,|\\-|\\/){1}([0-9]|[01][0-9]|2[0-3]) )|([0-9]|[01][0-9]|2[0-3]) |(\\* ))((([0-9]|[0-2][0-9]|3[01])(\\,|\\-|\\/){1}([0-9]|[0-2][0-9]|3[01]) )|(([0-9]|[0-2][0-9]|3[01]) )|(\\? )|(\\* )|(([1-9]|[0-2][0-9]|3[01]) )|([1-7] )|( )|([1-7]\\#[1-4] ))((([1-9]|0[1-9]|1[0-2])(\\,|\\-|\\/){1}([1-9]|0[1-9]|1[0-2]) )|([1-9]|0[1-9]|1[0-2]) |(\\* ))(([1-7](\\,|\\-|\\/){1}[1-7] )|([1-7] )|(\\? )|(\\* )|(([1-7] )|([1-7]\\#[1-4]) ))((19[789][0-9]|20[0-9][0-9])\\-(19[789][0-9]|20[0-9][0-9])))`).test(value)) {
                setSchedule(value);
                setSetup(5);
            }
            else {
                onError("日程格式不正确");
            }
        }
        else {
            onError("日程不能为空");
        }
    };
    return (react_1.default.createElement(ink_1.Box, { flexDirection: 'column' },
        setup === 0 && (react_1.default.createElement(Input_1.default, { label: '\u6807\u9898', initValue: title, placeholder: '\u8BF7\u8F93\u5165\u901A\u77E5\u6807\u9898', onConfirm: onTitleConfirm })),
        setup === 1 && (react_1.default.createElement(Input_1.default, { label: '\u4FE1\u606F', initValue: message, placeholder: '\u8BF7\u8F93\u5165\u901A\u77E5\u4FE1\u606F', onConfirm: onMessageConfirm })),
        setup === 2 && (react_1.default.createElement(Select_1.default, { label: '\u60A8\u60F3\u591A\u4E45\u901A\u77E5\u60A8\u4E00\u6B21\uFF1F', placeholder: '\u901A\u77E5\u5468\u671F', initialIndex: cycle ? cycleList.findIndex(item => item.value === cycle) : 0, items: cycleList, onConfirm: onSelectCycle })),
        setup === 3 && cycle === "week" && (react_1.default.createElement(Select_1.default, { label: '\u60A8\u60F3\u5468\u51E0\u901A\u77E5\u60A8\uFF1F', initialIndex: week ? weekList.findIndex(item => item.value === week) : 0, items: weekList, onConfirm: onSelectWeek })),
        setup === 4 && (react_1.default.createElement(Input_1.default, { label: '\u65F6\u95F4', initValue: time, placeholder: '\u8BF7\u8F93\u5165\u65F6\u95F4\uFF0C\u683C\u5F0F\u4E3A\uFF08\u65F6:\u5206:\u79D2\uFF09\uFF0C\u4F8B\u5982\uFF1A09:10:59', onConfirm: onTimeConfirm })),
        setup === 5 && (react_1.default.createElement(Select_1.default, { label: '\u60A8\u8981\u542F\u7528\u8FD9\u4E2A\u901A\u77E5\u5417\uFF1F', initialIndex: isTurnOn ? 0 : 1, items: isTurnList, onConfirm: onSelectIsTurnOn })),
        setup === 6 && (react_1.default.createElement(Input_1.default, { label: '\u5907\u6CE8', initValue: remark, placeholder: '\u8BF7\u8F93\u5165\u5907\u6CE8', onConfirm: onRemarkConfirm })),
        setup === 7 && (react_1.default.createElement(Input_1.default, { label: '\u65E5\u7A0B', initValue: schedule, placeholder: '\u8BF7\u8F93\u5165\u65E5\u7A0B', onConfirm: onScheduleConfirm }))));
};
exports.default = SetForm;
